
(defun export-o-matic (package)
  (flet 
      ((symbol-function-or-nil (symbol)
         (if (and (fboundp symbol) 
                  (not (macro-function symbol))
                  (not (special-operator-p symbol)))
             (symbol-function symbol))))
    (mapcar #'(lambda (x) (format t ":~A "x))
            (sort 
             (loop 
                for sym being each symbol of package
                when (and
                      (eq (symbol-package sym) (find-package package))
                      (not (string= (subseq (symbol-name sym) 0 1) "%"))
                      (or
                       (symbol-function-or-nil sym)
                        (string= (subseq (symbol-name sym) 0 1) "*")
                        (string= (subseq (symbol-name sym) 0 1) "+")))
                collect (symbol-name sym))
             #'string>))))
    

            
                
          
          